/* Sobel filter MEX-gateway */

#include <mex.h>
#include "sobel.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, 
	const mxArray *prhs[])
{
    double 	*img, *out_h, *out_v;
    int		rows, cols;
    
    /* Declarations*/
    if (nrhs != 1) { 
	mexErrMsgTxt("One input arguments required.\n"); 
    } else if (nlhs > 2) {
	mexErrMsgTxt("Too many output arguments.\n"); 
    } 


    /* We only handle doubles */
    if (!mxIsDouble(prhs[0])) {
	mexErrMsgTxt("Input image should be double.\n");
    }
    
    img   = mxGetPr(prhs[0]);
    cols  = mxGetN(prhs[0]);
    rows  = mxGetM(prhs[0]);

    /* Create output matrices: */ 
    plhs[0] = mxCreateDoubleMatrix(cols, rows, mxREAL);
    out_h   = mxGetPr(plhs[0]);
    plhs[1] = mxCreateDoubleMatrix(cols, rows, mxREAL);
    out_v   = mxGetPr(plhs[1]);

    sobel(img, rows, cols, out_h, out_v);
    
    return;
}
