/* Sobel filter an image */

int coord(int i, int j, int cols)
{
    return j * cols + i;
}

/* Perform a very simple unrolled convolution: */
double sobel_v(double *img, int x, int y, int cols)
{
	double val = 0;
	
	val += img[coord(x-1, y-1, cols)] * -1;
	val += img[coord(x  , y-1, cols)] * -2;
	val += img[coord(x+1, y-1, cols)] * -2;
	
	val += img[coord(x-1, y+1, cols)] *  1;
	val += img[coord(x  , y+1, cols)] *  2;
	val += img[coord(x+1, y+1, cols)] *  2;

	return val;
}

double sobel_h(double *img, int x, int y, int cols)
{
	double val = 0;
	
	val += img[coord(x-1, y-1, cols)] * -1;
	val += img[coord(x-1, y  , cols)] * -2;
	val += img[coord(x-1, y+1, cols)] * -2;
	
	val += img[coord(x+1, y-1, cols)] *  1;
	val += img[coord(x+1, y  , cols)] *  2;
	val += img[coord(x+1, y+1, cols)] *  2;

	return val;
}

void sobel(double *img, int rows, int cols, double *out_h, double *out_v)
{
    int i, j; 

    /* Loop over the image. Note the bounds start at one so we don't read
     * off the edge. */
    for (i = 1; i < rows - 1; i++) {
	for (j = 1; j < cols - 1; j++) {
	    out_h[coord(i, j, cols)] = sobel_h(img, i, j, cols);
	    out_v[coord(i, j, cols)] = sobel_v(img, i, j, cols);
	}
    }

}
